#include <method.h>

//  yang  celular eh :96520238

inline void
method_translate (FILE * fd, method_t * method,
		  void (*algorithim) (FILE *, method_t *))
{
  algorithim (fd, method);
}

char *
__method_str (char *name, method_t * method)
{
  char *str = NULL;
  asprintf (&str, "%s = [ name = %s ]", name, method->name);
  assert (str);
  return str;
}

inline void
method_load (method_t * method)
{

  Agnode_t *function = method->implementation;

  char *str = get_namedattr (function, "name");
  method->name = str;

  Agnode_t *block = resolve_path (function, 1, "cBlock");
  method->block = block;


  Agnode_t *prototype = resolve_path (function, 1, "cFunctionType");

  method->returns = NULL;
  if (get_fschild (prototype))
    {
      method->returns = type_new (get_fschild (prototype));
      //str = type_str( method->returns );
      //printf( "%s %s()\n", str, method->name  );
    }

  Agnode_t *args = resolve_path (prototype, 1, "cFunctionParameterList");

  if (args)
    {

      Agedge_t *e;
      for_each_child (e, args, cFunctionParameter)
      {
	Agnode_t *parameter = e->head;
	var_t *var = var_new (parameter);
	assert (var);

	varn_t *varnode = list_add (method->parameters, varn_t);
	assert (varnode);
	varnode->var = var;
      }

    }



}

static inline void
method_load_decl (method_t * method, Agnode_t * object)
{
  var_t *var = var_new (object);
  assert (var);

  varn_t *varnode = NULL;
  linkedlist_t *list = NULL;

  varnode = list_add (method->variables, varn_t);
  assert (varnode);
  varnode->var = var;
}


static inline void
method_load_block (method_t * method, Agnode_t * root)
{
  Agedge_t *e;
  Agedge_t *obj;

  for_each_child (e, root, cObjectList)
  {
    for_each_child (obj, e->head, cObject)
    {
      method_load_decl (method, obj->head);
    }
  }

  for_each_child (obj, root, cObject)
  {
    method_load_decl (method, obj->head);
  }

  //loads variable declarations recursively on diferent contexts

  for_each_child (obj, root, cBlock)
  {
    method_load_block (method, obj->head);
  }

  for_each_child (obj, root, cIfStatement)
  {
    method_load_block (method, obj->head);
  }

  for_each_child (obj, root, cSwitchStatement)
  {
    method_load_block (method, obj->head);
  }

  for_each_child (obj, root, cCaseLabel)
  {
    method_load_block (method, obj->head);
  }

  for_each_child (obj, root, cDefaultLabel)
  {
    method_load_block (method, obj->head);
  }

  for_each_child (obj, root, cForLoop)
  {
    method_load_block (method, obj->head);
  }

}


inline void
method_elaborate (method_t * method)
{

  Agedge_t *e;
  Agedge_t *obj;

  if (method->block == NULL)
    {
      panic ("can't elaborate method %s : implementation not found!",
	     method->name);
    }

  method_load_block (method, method->block);

}

inline method_t *
method_new (Agnode_t * root)
{
  method_t *m = (method_t *) malloc (sizeof (method_t));
  assert (m);
  m->implementation = root;

  m->sensitivity_def = list_new ();
  m->sensitivity_pos = list_new ();
  m->sensitivity_neg = list_new ();

  m->parameters = list_new ();
  m->variables = list_new ();

  m->sc_method = false;

  method_load (m);

  return m;
}

inline void
method_free (method_t * m)
{
  assert (m);

  list_free (m->sensitivity_def);
  list_free (m->sensitivity_pos);
  list_free (m->sensitivity_neg);

  list_free (m->parameters);
  list_free (m->variables);

  free (m);
  return;
}
