#ifndef MODULE_H
#define MODULE_H

#include <gvc.h>
#include <assert.h>
#include <malloc.h>
#define GNU_SOURCE
#include <string.h>
#include <linkedlist.h>

#include <util.h>
#include <method.h>
#include <instance.h>
#include <var.h>
//#include <scsignal.h>
#include <trunit.h>

typedef struct module
{
  char *name;
  Agnode_t *top;
  //Agnode_t *ctor;
  method_t *ctor;
  linkedlist_t *input;
  linkedlist_t *output;
  linkedlist_t *inout;
  linkedlist_t *signals;
  linkedlist_t *variables;
  linkedlist_t *methods;
  linkedlist_t *instances;
  linkedlist_t *enumerations;
} module_t;

typedef struct modulen
{
  listnode_t node;
  module_t *module;
} modulen_t;

inline module_t *module_new (Agnode_t * top);
inline void module_free (module_t * m);

#endif
