#include "window.h"


void window::comb_sigs(){

  in_ready = (state.read()==pre_read_st);


  // Memory address and Write Enable signals is modified in combinational function assyncronous
  // I do in this way to economize 1 clock cicle in the state machine
  vll_we = 0; // disables writing by default
  vll_addr = (ch.read() * 512) + l.read();
  if( state.read()==read_st )
  {
    vll_we = 1;
    vll_addr = (ch.read() * 512) + (32 * ((ch.read() == 0) ? block_0.read() : block_1.read()) + j.read());
  }
  
  vllrom_addr = 32 * i.read() + j.read();
  
  
  

  if(in_ready && in_trans && j.read()==0)
    nch=in_nch.read();
  else
    nch = prev_nch;


  k = (ch.read() == 0) ? block_0.read()+i.read() : block_1.read()+i.read();


  if((i.read()%2)==0){
    if(j.read() < 16)
      ind=16+j.read();//ind=32-(16-j.read());
    else
      ind=48-j.read();//ind=32-(j.read()-16);
  }
  else{
    if(j.read() < 16)
      ind=16-j.read();
    else
      ind=j.read()-16;
  }

  
  l = 32*k.read() + ind.read();
  

  
  MAddr = 0;
  //  out_nch=nch.read();
}

void window::fsm()
{
  
  if(Reset_n==0){
    i=0; //don't care
    Sj=0; //don't care

    state = pre_read_st;

    j=0;
    prev_nch=0;
    ch=0;
    block_0=15;
    block_1=15;
    valid_0=16;
    valid_1=16;


    MCmd = OCP_NULL;
    mul_a = 0;

  }
  else{

    MCmd = OCP_NULL;  // Keep in OCP_NULL (only OCP_WRITE in send state)
    prev_nch = nch;

    switch(state)
    {

        case pre_read_st:
	  if(in_trans)
	  {
	    // Prepare to Write in ram memory in next clock (state = read_st)
	    vll_in = data_in;
            state = read_st;
	  }

	  break;


        case read_st:
	    //vll[ch.read()][32*block[ch.read()].read()+j.read()] = data_in;
            j=j.read()+1;
            i=0;
            if(j.read()==31)
	    {
	      state = mem_read_proc_st;

              if (ch.read() == 0) {
                 if(valid_0.read()!=0)
                    valid_0=valid_0.read()-1;
              } else {
                 if(valid_1.read()!=0)
                    valid_1=valid_1.read()-1;
              }

            }
	    else{
	      state = pre_read_st;
	    }

          break;

        // Intermadiate state to read from memory
	// Here we can read since the address was modified assincronously
        case mem_read_proc_st:
          state = mem_read_proc2_st;
          break;
          
        case mem_read_proc2_st:
	  mul_b = vllrom_out.read(); // read from rom
	  
	  if (ch.read() == 0) {
	    if(k.read() >=  valid_0.read())
	      mul_a = vll_out.read(); // read from memory
	    else
	      mul_a = 0;
	  } else {
	    if(k.read() >=  valid_1.read())
	      mul_a = vll_out.read(); // read from memory
	    else
	      mul_a = 0;
	  }

	  state = proc_st;

	  break;

        
        case proc_st:
	  //TODO: verificar SCmdAccept
          //if( SCmdAccept.read()==1 || i.read()!=15 )
	  {
	    state = mem_read_proc_st;

            if(i.read() == 0)
              Sj = (sc_uint<32>)mul_c.read();
            else
              Sj = Sj.read() + mul_c.read();

            i = i.read() + 1;
            if(i.read() == 15)
	    {
              j = j.read() + 1;
              if(j.read() == 31){
                if (ch.read() == 0)
                  block_0=block_0.read()-1;
                else
                  block_1=block_1.read()-1;

                if(nch.read()==2)
                  ch=ch.read() + 1;
		state = pre_read_st;
              }
	    }
          }

	  if( i.read() == 14 )
	  {
	    state = mem_read_send_st;
	  }

          break;


	// Intermadiate state to read from memory
	// Here we can read since the address was modified assincronously
        case mem_read_send_st:
          state = mem_read_send2_st;
          break;
                        
        case mem_read_send2_st:       
	  mul_b = vllrom_out.read(); // read from rom

	  if (ch.read() == 0) {
	    if(k.read() >=  valid_0.read())
	      mul_a = vll_out.read(); // read from memory
	    else
	      mul_a = 0;
	  } else {
	    if(k.read() >=  valid_1.read())
	      mul_a = vll_out.read(); // read from memory
	    else
	      mul_a = 0;
	  }

	  state = send_st;
	  break;


        case send_st:
	  MCmd = OCP_WR;
	  MData = Sj.read() + mul_c.read();

          if( SCmdAccept.read()==1 ){
	    //printf("0x%08X\n",(int)(Sj.read() + mul_c.read()));      
            state = mem_read_proc_st;
          }else
            state = send_st;

          break;
    }
  }
}

/*
void window::dump()
{
    mula_out = mul_a.read();
    mulb_out = mul_b.read();
    mulc_out = mul_c.read();

    mem_in = vll_in.read();
    mem_addr = vll_addr.read();
    mem_out = vll_out.read();
    mem_we = vll_we.read();
}*/
